<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Louvain Algorithm: src/community.c File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Louvain Algorithm
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">community.c File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &lt;stdio.h&gt;</code><br />
<code>#include &lt;stdlib.h&gt;</code><br />
<code>#include &lt;string.h&gt;</code><br />
<code>#include &lt;math.h&gt;</code><br />
<code>#include &quot;<a class="el" href="community_8h_source.html">community.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="graph_8h_source.html">graph.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="linkedlist_8h_source.html">linkedlist.h</a>&quot;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for community.c:</div>
<div class="dyncontent">
<div class="center"><img src="community_8c__incl.png" border="0" usemap="#src_2community_8c" alt=""/></div>
<map name="src_2community_8c" id="src_2community_8c">
<area shape="rect" id="node6" href="community_8h.html" title="community.h" alt="" coords="407,80,505,107"/>
<area shape="rect" id="node7" href="graph_8h.html" title="graph.h" alt="" coords="374,155,439,181"/>
<area shape="rect" id="node8" href="linkedlist_8h.html" title="linkedlist.h" alt="" coords="482,155,566,181"/>
</map>
</div>
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a25861273f2bfea212875fc19b6227346"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="community_8c.html#a25861273f2bfea212875fc19b6227346">calculate_weights</a> (<a class="el" href="structcommunity__t.html">community_t</a> *comm, <a class="el" href="structgraph__t.html">graph_t</a> *graph)</td></tr>
<tr class="separator:a25861273f2bfea212875fc19b6227346"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a78f31c0399e157c4829c634e9762b3fa"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structcommunity__set__t.html">community_set_t</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="community_8c.html#a78f31c0399e157c4829c634e9762b3fa">create_community_set</a> (<a class="el" href="structgraph__t.html">graph_t</a> *graph)</td></tr>
<tr class="separator:a78f31c0399e157c4829c634e9762b3fa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a681b759eb1056a6cccd60161b6a2749a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="community_8c.html#a681b759eb1056a6cccd60161b6a2749a">add_node_to_community</a> (<a class="el" href="structcommunity__set__t.html">community_set_t</a> *set, int comm_index, int node_id)</td></tr>
<tr class="separator:a681b759eb1056a6cccd60161b6a2749a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad4e025b0ff4789827ae2aaf070c6393a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="community_8c.html#ad4e025b0ff4789827ae2aaf070c6393a">remove_node_from_community</a> (<a class="el" href="structcommunity__set__t.html">community_set_t</a> *set, int comm_index, int node_id)</td></tr>
<tr class="separator:ad4e025b0ff4789827ae2aaf070c6393a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9296e83d2b1f1fb698fb550dc4eaf3b8"><td class="memItemLeft" align="right" valign="top">char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="community_8c.html#a9296e83d2b1f1fb698fb550dc4eaf3b8">neighboring_commuities</a> (<a class="el" href="structcommunity__set__t.html">community_set_t</a> *set, int node_id)</td></tr>
<tr class="separator:a9296e83d2b1f1fb698fb550dc4eaf3b8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad774ff0f64931b2a26dd56014014f6c0"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="community_8c.html#ad774ff0f64931b2a26dd56014014f6c0">find_community</a> (<a class="el" href="structcommunity__set__t.html">community_set_t</a> *set, int target)</td></tr>
<tr class="separator:ad774ff0f64931b2a26dd56014014f6c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a055e81a3e6d9f9faf71343c2db4703a7"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="community_8c.html#a055e81a3e6d9f9faf71343c2db4703a7">possible_new_links</a> (<a class="el" href="structcommunity__set__t.html">community_set_t</a> *set, int comm_index, int node_id)</td></tr>
<tr class="separator:a055e81a3e6d9f9faf71343c2db4703a7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a97f471d6cfb2b90ba69089988d9e7efe"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="community_8c.html#a97f471d6cfb2b90ba69089988d9e7efe">modularity</a> (<a class="el" href="structcommunity__set__t.html">community_set_t</a> *set)</td></tr>
<tr class="separator:a97f471d6cfb2b90ba69089988d9e7efe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5be1f3cb5477970bdd9ebc04801f407b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="community_8c.html#a5be1f3cb5477970bdd9ebc04801f407b">collapse</a> (<a class="el" href="structcommunity__set__t.html">community_set_t</a> *set)</td></tr>
<tr class="separator:a5be1f3cb5477970bdd9ebc04801f407b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8e3b186f3dcd7d9760f05ed6f1723753"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="community_8c.html#a8e3b186f3dcd7d9760f05ed6f1723753">clean_set</a> (<a class="el" href="structcommunity__set__t.html">community_set_t</a> *set)</td></tr>
<tr class="separator:a8e3b186f3dcd7d9760f05ed6f1723753"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a194dd56a0aa66d67628938e9b0bbff29"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="community_8c.html#a194dd56a0aa66d67628938e9b0bbff29">print_communities</a> (<a class="el" href="structcommunity__set__t.html">community_set_t</a> *set)</td></tr>
<tr class="separator:a194dd56a0aa66d67628938e9b0bbff29"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Function Documentation</h2>
<a id="a681b759eb1056a6cccd60161b6a2749a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a681b759eb1056a6cccd60161b6a2749a">&#9670;&nbsp;</a></span>add_node_to_community()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void add_node_to_community </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structcommunity__set__t.html">community_set_t</a> *&#160;</td>
          <td class="paramname"><em>set</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>comm_index</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>node_id</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to add a node into a given community. It makes sure to update also the total inner and external weight count (as this improves speed in modularity calculation). </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">set</td><td>The set of communities. </td></tr>
    <tr><td class="paramname">comm_index</td><td>The index of the community to be modified in the set. </td></tr>
    <tr><td class="paramname">node_id</td><td>The id of the node to be added. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a25861273f2bfea212875fc19b6227346"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a25861273f2bfea212875fc19b6227346">&#9670;&nbsp;</a></span>calculate_weights()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void calculate_weights </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structcommunity__t.html">community_t</a> *&#160;</td>
          <td class="paramname"><em>comm</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td>
          <td class="paramname"><em>graph</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Utility function to calculate the internal and external weights of a community. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">comm</td><td>Pointer to the community of interest. </td></tr>
    <tr><td class="paramname">graph</td><td>Pointer to the graph containing the nodes of the community. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a8e3b186f3dcd7d9760f05ed6f1723753"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8e3b186f3dcd7d9760f05ed6f1723753">&#9670;&nbsp;</a></span>clean_set()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void clean_set </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structcommunity__set__t.html">community_set_t</a> *&#160;</td>
          <td class="paramname"><em>set</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to free the dynamically allocated memory for the set of communities. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">set</td><td>The set of communities to be freed. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a5be1f3cb5477970bdd9ebc04801f407b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5be1f3cb5477970bdd9ebc04801f407b">&#9670;&nbsp;</a></span>collapse()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void collapse </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structcommunity__set__t.html">community_set_t</a> *&#160;</td>
          <td class="paramname"><em>set</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to reduce the dimension of a community set after a pass of the Louvain algorithm. It removes the communities that have no nodes in them. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">set</td><td>A pointer to a set of communities. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a78f31c0399e157c4829c634e9762b3fa"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a78f31c0399e157c4829c634e9762b3fa">&#9670;&nbsp;</a></span>create_community_set()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structcommunity__set__t.html">community_set_t</a>* create_community_set </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td>
          <td class="paramname"><em>graph</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to create a set of communities each containing a single node of the given graph. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">graph</td><td>The graph from which one wants to create the set of communities (one for each node). </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A pointer to a new filled up set of communities. </dd></dl>

</div>
</div>
<a id="ad774ff0f64931b2a26dd56014014f6c0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad774ff0f64931b2a26dd56014014f6c0">&#9670;&nbsp;</a></span>find_community()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int find_community </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structcommunity__set__t.html">community_set_t</a> *&#160;</td>
          <td class="paramname"><em>set</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>target</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function that returns the index of the community that contains the specified node </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">set</td><td>The set of communities </td></tr>
    <tr><td class="paramname">target</td><td>The index of the node one wants to find the community </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The index of the community that contains the targeted node. -1 if not found </dd></dl>

</div>
</div>
<a id="a97f471d6cfb2b90ba69089988d9e7efe"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a97f471d6cfb2b90ba69089988d9e7efe">&#9670;&nbsp;</a></span>modularity()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double modularity </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structcommunity__set__t.html">community_set_t</a> *&#160;</td>
          <td class="paramname"><em>set</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to calculate the modularity of a set of communities. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">set</td><td>The given set of communities. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The modularity of the set. </dd></dl>

</div>
</div>
<a id="a9296e83d2b1f1fb698fb550dc4eaf3b8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9296e83d2b1f1fb698fb550dc4eaf3b8">&#9670;&nbsp;</a></span>neighboring_commuities()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">char* neighboring_commuities </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structcommunity__set__t.html">community_set_t</a> *&#160;</td>
          <td class="paramname"><em>set</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>node_id</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to produce an array containing '1' if the community is a neighbor to the specified one (or it's the same community) or '0' if the community isn't a neighbor of the one indexed. A community is said to be a neighbor of another one if exists at least a link between two of their nodes. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">set</td><td>The set of communities. </td></tr>
    <tr><td class="paramname">node_id</td><td>Index of the node one wants to find the neighbor communities of. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Dynamically allocated array of "boolean" values to identify neighboring communities. No need to specify the length for it has a number of elements equal to the num_communities of the set. </dd></dl>

</div>
</div>
<a id="a055e81a3e6d9f9faf71343c2db4703a7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a055e81a3e6d9f9faf71343c2db4703a7">&#9670;&nbsp;</a></span>possible_new_links()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int possible_new_links </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structcommunity__set__t.html">community_set_t</a> *&#160;</td>
          <td class="paramname"><em>set</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>comm_index</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>node_id</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to calculate the possible new links increase to the internal weight of the community if the given node was added. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">set</td><td>The set of communities. </td></tr>
    <tr><td class="paramname">comm_index</td><td>The index of the community. </td></tr>
    <tr><td class="paramname">node_id</td><td>The number of the given node. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The sum of all the possible new links's weight. </dd></dl>

</div>
</div>
<a id="a194dd56a0aa66d67628938e9b0bbff29"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a194dd56a0aa66d67628938e9b0bbff29">&#9670;&nbsp;</a></span>print_communities()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void print_communities </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structcommunity__set__t.html">community_set_t</a> *&#160;</td>
          <td class="paramname"><em>set</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to print the communities. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">set</td><td>The set one wants to print the communities of. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ad4e025b0ff4789827ae2aaf070c6393a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad4e025b0ff4789827ae2aaf070c6393a">&#9670;&nbsp;</a></span>remove_node_from_community()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void remove_node_from_community </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structcommunity__set__t.html">community_set_t</a> *&#160;</td>
          <td class="paramname"><em>set</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>comm_index</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>node_id</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to remove a node into a given community. It makes sure to update also the total inner and external weight count (as this improves modularity calculation). </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">set</td><td>The set of communities. </td></tr>
    <tr><td class="paramname">comm_index</td><td>The index of the community to be modified in the set. </td></tr>
    <tr><td class="paramname">node_id</td><td>The id of the node to be added. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
